The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Asymp Class Reference

STK asymptotic curve envelope class. More...

`#include <Asymp.h>`

Inheritance diagram for stk::Asymp:

## Public Member Functions
| Asymp (void)
| Default constructor.
| ~Asymp (void)
| Class destructor.
void | keyOn (void)
| Set target = 1.
void | keyOff (void)
| Set target = 0.
void | setTau (StkFloat tau)
| Set the asymptotic rate via the time factor tau (must be > 0). More...
void | setTime (StkFloat time)
| Set the asymptotic rate based on a time duration (must be > 0).
void | setT60 (StkFloat t60)
| Set the asymptotic rate such that the target value is perceptually reached (to within -60dB of the target) in t60 seconds.
void | setTarget (StkFloat target)
| Set the target value.
void | setValue (StkFloat value)
| Set current and target values to value.
int | getState (void) const
| Return the current envelope state (0 = at target, 1 otherwise).
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (void)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs. More...
Public Member Functions inherited from stk::Generator
| Generator (void)
| Class constructor.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes. More...

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate. More...
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK asymptotic curve envelope class.

This class implements a simple envelope generator which asymptotically approaches a target value. The algorithm used is of the form:

y[n] = a y[n-1] + (1-a) target,

where a = exp(-T/tau), T is the sample period, and tau is a time constant. The user can set the time constant (default value = 0.3) and target value. Theoretically, this recursion never reaches its target, though the calculations in this class are stopped when the current value gets within a small threshold value of the target (at which time the current value is set to the target). It responds to keyOn and keyOff messages by ramping to 1.0 on keyOn and to 0.0 on keyOff.

by Perry R. Cook and Gary P. Scavone, 1995–2019.

## Member Function Documentation

## ◆ setTau()

void stk::Asymp::setTau | ( | StkFloat | tau | ) |

Set the asymptotic rate via the time factor tau (must be > 0).

The rate is computed as described above. The value of tau must be greater than zero. Values of tau close to zero produce fast approach rates, while values greater than 1.0 produce rather slow rates.

## ◆ tick()

StkFrames & stk::Asymp::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Generator.

128 {
129 #if defined(_STK_DEBUG_)
130 if ( channel >= frames.channels() ) {
131 oStream_ << "Asymp::tick(): channel and StkFrames arguments are incompatible!";
132 handleError( StkError::FUNCTION_ARGUMENT );
133 }
134 #endif
135
136 StkFloat *samples = &frames[channel];
137 unsigned int hop = frames.channels();
138 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
139 *samples = Asymp::tick();
140
141 return frames;
142 }
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.
stk::Asymp::tick
StkFloat tick(void)
Compute and return one output sample.
Definition: Asymp.h:102

The documentation for this class was generated from the following file:

- Asymp.h

The Synthesis ToolKit in C++ (STK)
©1995--2019 Perry R. Cook and Gary P. Scavone. All Rights Reserved.